import { HttpClient } from '@angular/common/http';
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';
import { NewsletterSubscription } from '../models/subscription.model';

@Injectable({
  providedIn: 'root',
})
export class NewsletterService {
  constructor(private http: HttpClient) {}

  public subscribe(email: string): Observable<NewsletterSubscription> {
    return this.http.post<NewsletterSubscription>('/api/newsletter/subscribe', { email });
  }

  public unsubscribe(email: string): Observable<NewsletterSubscription> {
    return this.http.post<NewsletterSubscription>('/api/newsletter/unsubscribe', { email });
  }

  public find(email: string): Observable<NewsletterSubscription> {
    return this.http.get<NewsletterSubscription>(`/api/newsletter?email=${email}`);
  }
}
