import { Component, EventEmitter, Input, Output } from '@angular/core';

@Component({
  selector: 'app-v3-tag-item',
  templateUrl: './tag-item.component.html',
  styleUrls: ['./tag-item.component.scss'],
})
export class TagItemV3Component {
  /** Tag label */
  @Input() label: string = 'Bouton';

  /** How large should be the button ? */
  @Input() size?: 'small' | 'medium' = 'medium';

  /** Is the tag selected ? */
  @Input() selected?: boolean = false;

  /** Should the button be clickable ? */
  @Input() clickable?: boolean = true;

  /** Should the button be disabled */
  @Input() disabled?: boolean = false;

  /** Sets the position of the icon if one provided */
  @Input() iconPosition?: 'left' | 'right' = 'left';

  /** Folder of the icon ex: assets/ico */
  @Input() iconFolder?: string = 'ico';

  /** Icon name */
  @Input() iconName?: string;

  /** Click handler */
  @Output() action = new EventEmitter<Event>();

  public get classes(): string[] {
    return [this.size, this.selected ? 'selected' : '', this.clickable ? 'clickable' : 'unclickable'];
  }

  public get iconSize() {
    return this.size === 'small' ? 'icon-12' : 'icon-16';
  }
}
